summaryrefslogtreecommitdiffstats
path: root/misc
diff options
context:
space:
mode:
author Ljubomir Kurij2013-05-05 08:16:05 +0200
committer Niels Horn2013-05-13 03:20:47 +0200
commit68fef2d19d9b63ce0d4799e3cf5358a15c7958c3 (patch)
tree6d985ef0202a31572ef8a93d98a009ef6a991c8b /misc
parent92a1ccc987b81dc5fb52c88dfeab64bcabd2d4ac (diff)
downloadslackbuilds-68fef2d19d9b63ce0d4799e3cf5358a15c7958c3.tar.gz
misc/cflow: Added (Flow graph generator for C projects)
Signed-off-by: Robby Workman <rworkman@slackbuilds.org>
Diffstat (limited to 'misc')
-rw-r--r--misc/cflow/README11
-rw-r--r--misc/cflow/cflow.SlackBuild105
-rw-r--r--misc/cflow/cflow.info10
-rw-r--r--misc/cflow/slack-desc19
4 files changed, 145 insertions, 0 deletions
diff --git a/misc/cflow/README b/misc/cflow/README
new file mode 100644
index 0000000000..c9732ff3fb
--- /dev/null
+++ b/misc/cflow/README
@@ -0,0 +1,11 @@
+GNU cflow analyzes a collection of C source files and prints a graph,
+charting control flow within the program.
+
+GNU cflow is able to produce both direct and inverted flowgraphs for
+C sources. Optionally a cross-reference listing can be generated.
+Two output formats are implemented: POSIX and GNU (extended).
+
+Input files can optionally be preprocessed before analyzing.
+
+The package also provides Emacs major mode for examining the produced
+flowcharts in Emacs.
diff --git a/misc/cflow/cflow.SlackBuild b/misc/cflow/cflow.SlackBuild
new file mode 100644
index 0000000000..4111ed5e13
--- /dev/null
+++ b/misc/cflow/cflow.SlackBuild
@@ -0,0 +1,105 @@
+#!/bin/sh
+
+# Slackware build script for cflow
+
+# Copyright 2013 Ljubomir Kurij kurijlj@gmail.com
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=cflow
+VERSION=${VERSION:-1.4}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i486 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.xz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --infodir=/usr/info \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --build=$ARCH-slackware-linux \
+ --disable-nls
+
+make
+make install DESTDIR=$PKG
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+rm -f $PKG/usr/info/dir
+gzip -9 $PKG/usr/info/*.info*
+
+find $PKG -name perllocal.pod \
+ -o -name ".packlist" \
+ -o -name "*.bs" \
+ | xargs rm -f
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ AUTHORS COPYING ChangeLog* INSTALL NEWS README THANKS TODO\
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/misc/cflow/cflow.info b/misc/cflow/cflow.info
new file mode 100644
index 0000000000..fdd5fc97cd
--- /dev/null
+++ b/misc/cflow/cflow.info
@@ -0,0 +1,10 @@
+PRGNAM="cflow"
+VERSION="1.4"
+HOMEPAGE="http://www.gnu.org/software/cflow/"
+DOWNLOAD="http://ftp.gnu.org/gnu/cflow/cflow-1.4.tar.xz"
+MD5SUM="b76b3b50588ec73824342f78379b4e0f"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES=""
+MAINTAINER="Ljubomir Kurij"
+EMAIL="kurijlj@gmail.com"
diff --git a/misc/cflow/slack-desc b/misc/cflow/slack-desc
new file mode 100644
index 0000000000..2f6b0b6a02
--- /dev/null
+++ b/misc/cflow/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+cflow: cflow (Flow graph generator for C projects)
+cflow:
+cflow: The cflow utility analyzes a collection of source files written in C
+cflow: programming language and outputs a graph charting dependencies between
+cflow: various functions.
+cflow:
+cflow: Homepage: http://www.gnu.org/software/cflow/
+cflow: Maintainer: Sergey Poznyakoff <gray@gnu.org>
+cflow:
+cflow:
+cflow: